// This file is part of the Dynpeak toolbox
// Copyright (C) 2012 - INRIA - Serge Steer
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
function dynpeak_check_pars()
  C=gcbo.parent.children
  E=C(C.style=="edit")
  B=C(C.style=="pushbutton")
  OK=B(2)
  for k=1:size(E,'*')
    h=E(k)
    clear V
    ok=execstr("V="+h.string,'errcatch')==0
    if ~ok then
      h.ForegroundColor=[1 0 0];
      OK.enable="off";
      return
    end
    select h.tag
    case "period"
      if V<=0 then 
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
    case "globalreltol"
      if V<=0|V>100 then 
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
    case "localabstol"
      if V<=0 then 
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
    case "detectionthreshold"
      if V<0 then 
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
    case "threepointtol"
      if V<=0|V>100 then 
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
    case "Range"
      if or(V<0)|or(diff(V)<=0) then 
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
      ok=execstr("CV="+E(k-1).string,'errcatch')==0
      if ok&(size(CV,'*')<>size(V,'*')) then
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
    case "CV" then
      if or(V<0)|or(V>100) then 
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
      ok=execstr("Range="+E(k+1).string,'errcatch')==0
      if ok&(size(Range,'*')<>size(V,'*')) then
        h.ForegroundColor=[1 0 0];
        OK.enable="off";
        return
      end
      h.ForegroundColor=[0 0 0];
    end
  end
  OK.enable="on";
endfunction
