function dynpeak_popup_callback(sel,win)
  fig=findobj("figure_id", win);
  fig_ud=fig.user_data;
  params=fig_ud.dynpeak;
  peak_alg_pars=params.detectionparams;
  ks=fig_ud.dynpeak.selected;
  h=fig_ud.dynpeak.history;
  sig=params.LH;
  T=params.T;
  select sel
  case _("Ignore selected point") then //Ignore selected point
    peak_alg_pars.ignoredpoints=unique([peak_alg_pars.ignoredpoints;ks])
    fig_ud.dynpeak.selected=[]
    fig_ud.dynpeak.detectionparams=peak_alg_pars
    fig_ud.dynpeak.history($+1)=[-1,ks,sig(ks),T(ks)];
    set(fig,"user_data",fig_ud)
    indpeaks = lhpeaks(sig,T,peak_alg_pars);
    dynpeak_update_graph(fig,T,sig,indpeaks);
  case _("Accept selected point") then //Ignore selected point
    peak_alg_pars.ignoredpoints(peak_alg_pars.ignoredpoints==ks)=[];
    fig_ud.dynpeak.detectionparams=peak_alg_pars
    fig_ud.dynpeak.history($+1)=[2,ks,sig(ks),T(ks)];
    set(fig,"user_data",fig_ud)
    indpeaks = lhpeaks(sig,T,peak_alg_pars);
    dynpeak_update_graph(fig,T,sig,indpeaks);
  case _("Impose a peak at selected point") then
    peak_alg_pars=params.detectionparams
    peak_alg_pars.imposedpeaks=unique([peak_alg_pars.imposedpeaks;ks])
    fig_ud.dynpeak.selected=[]
    fig_ud.dynpeak.detectionparams=peak_alg_pars
    fig_ud.dynpeak.history($+1)=[1,ks,sig(ks),T(ks)];
    set(fig,"user_data",fig_ud)
    indpeaks = lhpeaks(sig,T, peak_alg_pars);
    dynpeak_update_graph(fig,T,sig,indpeaks);
  case _("Undo (Ctrl-Z)")
    h=fig_ud.dynpeak.history
    if size(h)>0 then
      last=h($);
      ks=last(2)
      select last(1)
      case -1 then //undo IgnorePoint
        ignoredpoints=peak_alg_pars.ignoredpoints
        ignoredpoints(ignoredpoints==ks)=[]
        peak_alg_pars.ignoredpoints=ignoredpoints
      case 1 then //undo imposedpeaks
        imposedpeaks=peak_alg_pars.imposedpeaks
        imposedpeaks(imposedpeaks==ks)=[]
        peak_alg_pars.imposedpeaks=imposedpeaks
      case 2 then //undo Accept point
        peak_alg_pars.ignoredpoints=unique([peak_alg_pars.ignoredpoints;ks])
      end
      fig_ud.dynpeak.detectionparams=peak_alg_pars
      //update the history data structure
      h($)=null();
      fig_ud.dynpeak.history=h
      //recompute the peaks
      //disable selection
      fig_ud.dynpeak.selected=[];
      set(fig,"user_data",fig_ud)
      indpeaks = lhpeaks(sig,T, peak_alg_pars(:));
      dynpeak_update_graph(fig,T,sig,indpeaks);
    end
  end
  fig.event_handler_enable = "on";
endfunction
