// This file is part of the Dynpeak toolbox
// Copyright (C) 2012 - INRIA - Serge Steer
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
function dynpeak_set_parameters(win)
  fig=findobj("figure_id", win);
  fig_ud=fig.user_data
  default=fig_ud.dynpeak.detectionparams
  E=gcbo.user_data
  pars=[]
  for k=1:size(E,'*')
    h=E(k)
    execstr(h.tag+"="+h.string)
  end
  pars=struct("detectionthreshold",detectionthreshold,...
              "globalreltol",globalreltol/100,...
              "localabstol",localabstol,...
              "threepointtol",threepointtol/100,...
              "uncertainty",[Range(:),CV(:)/100]',...
              "period",period,...
              "imposedpeaks",default.imposedpeaks,...
              "ignoredpoints",default.ignoredpoints,...
              "selection",default.selection)
  fig.user_data.dynpeak.detectionparams =pars;
endfunction
